## libc++ 1.0~svn199600

=== CMakeLists.txt ===
# See www/CMake.html for instructions on how to build libcxx with CMake.

#===============================================================================
# Setup Project
#===============================================================================

project(libcxx CXX C)
cmake_minimum_required(VERSION 2.8)

set(PACKAGE_NAME libcxx)
set(PACKAGE_VERSION trunk-svn)
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "llvmbugs@cs.uiuc.edu")

# Add path for custom modules
set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  ${CMAKE_MODULE_PATH}
  )

# Require out of source build.
include(MacroEnsureOutOfSourceBuild)
MACRO_ENSURE_OUT_OF_SOURCE_BUILD(
 "${PROJECT_NAME} requires an out of source build. Please create a separate
 build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there."
 )

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(LIBCXX_BUILT_STANDALONE 1)
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================

# Define options.
option(LIBCXX_ENABLE_EXCEPTIONS "Use exceptions." ON)
option(LIBCXX_ENABLE_RTTI "Use run time type information." ON)
option(LIBCXX_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBCXX_ENABLE_PEDANTIC "Compile with pedantic enabled." ON)
option(LIBCXX_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBCXX_ENABLE_CXX0X "Enable -std=c++0x and use of c++0x language features if the compiler supports it." ON)
option(LIBCXX_ENABLE_SHARED "Build libc++ as a shared library." ON)
option(LIBCXX_INSTALL_SUPPORT_HEADERS "Install libc++ support headers." ON)

set(CXXABIS none libcxxabi libcxxrt libstdc++ libsupc++)
if (NOT DEFINED LIBCXX_CXX_ABI)
  set(LIBCXX_CXX_ABI "none")
endif()
set(LIBCXX_CXX_ABI "${LIBCXX_CXX_ABI}" CACHE STRING
    "Specify C++ ABI library to use." FORCE)
set_property(CACHE LIBCXX_CXX_ABI PROPERTY STRINGS ;${CXXABIS})

#===============================================================================
# Configure System
#===============================================================================

# Get triples.
include(GetTriple)
get_host_triple(LIBCXX_HOST_TRIPLE
  LIBCXX_HOST_ARCH
  LIBCXX_HOST_VENDOR
  LIBCXX_HOST_OS
  )
set(LIBCXX_HOST_TRIPLE ${LIBCXX_HOST_TRIPLE} CACHE STRING "Host triple.")
get_target_triple(LIBCXX_TARGET_TRIPLE
  LIBCXX_TARGET_ARCH
  LIBCXX_TARGET_VENDOR
  LIBCXX_TARGET_OS
  )
set(LIBCXX_TARGET_TRIPLE ${LIBCXX_TARGET_TRIPLE} CACHE STRING "Target triple.")

#===============================================================================
# Add an ABI library if appropriate
#===============================================================================

#
# _setup_abi: Set up the build to use an ABI library
#
# Parameters:
#   abidefines: A list of defines needed to compile libc++ with the ABI library
#   abilibs   : A list of libraries to link against
#   abifiles  : A list of files (which may be relative paths) to copy into the
#               libc++ build tree for the build.  These files will also be
#               installed alongside the libc++ headers.
#   abidirs   : A list of relative paths to create under an include directory
#               in the libc++ build directory.
#
macro(setup_abi_lib abipathvar abidefines abilibs abifiles abidirs)
  list(APPEND LIBCXX_CXX_FEATURE_FLAGS ${abidefines})
  set(${abipathvar} "${${abipathvar}}"
    CACHE STRINGS
    "Paths to ABI include directories separate by ';'."
    )
  set(LIBCXX_CXX_ABI_LIBRARIES ${abilibs})
  set(LIBCXX_ABILIB_FILES ${abifiles})
  file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/include")
  foreach(_d ${abidirs})
    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/include/${_d}")
  endforeach()
  set(LIBCXX_ABILIB_FILE_PATHS)
  foreach(fpath ${LIBCXX_ABILIB_FILES})
    set(found FALSE)
    foreach(incpath ${${abipathvar}})
      if (EXISTS "${incpath}/${fpath}")
        set(found TRUE)
        get_filename_component(dstdir ${fpath} PATH)
        get_filename_component(ifile ${fpath} NAME)
        add_custom_command(
          OUTPUT "${CMAKE_BINARY_DIR}/include/${dstdir}/${ifile}"
          COMMAND ${CMAKE_COMMAND} -E copy_if_different
            "${incpath}/${fpath}"
            "${CMAKE_BINARY_DIR}/include/${dstdir}"
          MAIN_DEPENDENCY "${incpath}/${fpath}"
          )
        list(APPEND LIBCXX_CXX_ABI_DEPS
          "${CMAKE_BINARY_DIR}/include/${dstdir}/${ifile}"
          )
      endif()
    endforeach()
    if (NOT found)
      message(FATAL_ERROR "Failed to find ${fpath}")
    endif()
  endforeach()
  add_custom_target(abilib_headers DEPENDS ${LIBCXX_CXX_ABI_DEPS})
  set(LIBCXX_CXX_ABI_DEPS abilib_headers)
  include_directories("${CMAKE_BINARY_DIR}/include")
  install(DIRECTORY "${CMAKE_BINARY_DIR}/include/"
    DESTINATION include/c++/v1
    FILES_MATCHING
    PATTERN "*"
    )
endmacro()

if ("${LIBCXX_CXX_ABI}" STREQUAL "libstdc++" OR
    "${LIBCXX_CXX_ABI}" STREQUAL "libsupc++")
  set(_LIBSUPCXX_INCLUDE_FILES
    cxxabi.h bits/c++config.h bits/os_defines.h bits/cpu_defines.h
    bits/cxxabi_tweaks.h bits/cxxabi_forced.h
    )
  if ("${LIBCXX_CXX_ABI}" STREQUAL "libstdc++")
    set(_LIBSUPCXX_DEFINES "-DLIBSTDCXX")
    set(_LIBSUPCXX_LIBNAME stdc++)
  else()
    set(_LIBSUPCXX_DEFINES "")
    set(_LIBSUPCXX_LIBNAME supc++)
  endif()
  setup_abi_lib("LIBCXX_LIBSUPCXX_INCLUDE_PATHS"
    "-D__GLIBCXX__ ${_LIBSUPCXX_DEFINES}"
    "${_LIBSUPCXX_LIBNAME}" "${_LIBSUPCXX_INCLUDE_FILES}" "bits"
    )
elseif ("${LIBCXX_CXX_ABI}" STREQUAL "libcxxabi")
  setup_abi_lib("LIBCXX_LIBCXXABI_INCLUDE_PATHS" ""
    "c++abi" "cxxabi.h" ""
    )
elseif ("${LIBCXX_CXX_ABI}" STREQUAL "libcxxrt")
  setup_abi_lib("LIBCXX_LIBCXXRT_INCLUDE_PATHS" "-DLIBCXXRT"
    "cxxrt" "cxxabi.h;unwind.h;unwind-arm.h;unwind-itanium.h" ""
    )
elseif (NOT "${LIBCXX_CXX_ABI}" STREQUAL "none")
  message(FATAL_ERROR
    "Currently libstdc++, libsupc++, libcxxabi, libcxxrt and none are "
    "supported for c++ abi."
    )
endif ()

# Configure compiler.
include(config-ix)

#===============================================================================
# Setup Compiler Flags
#===============================================================================

# Get required flags.
# On all systems the system c++ standard library headers need to be excluded.
if (MSVC)
  # MSVC only has -X, which disables all default includes; including the crt.
  # Thus, we do nothing and hope we don't accidentally include any of the C++
  # headers.
else()
  if (LIBCXX_HAS_NOSTDINCXX_FLAG)
    set(LIBCXX_CXX_REQUIRED_FLAGS -nostdinc++)
  endif()
  if (LIBCXX_ENABLE_CXX0X AND LIBCXX_HAS_STDCXX0X_FLAG)
    list(APPEND LIBCXX_CXX_REQUIRED_FLAGS -std=c++0x)
  endif()
endif()

macro(append_if list condition var)
  if (${condition})
    list(APPEND ${list} ${var})
  endif()
endmacro()

# Get warning flags
if (NOT MSVC)
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WALL_FLAG -Wall)
  set(LIBCXX_CXX_REQUIRED_FLAGS, -Werror=return-type)
endif()

append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_W_FLAG -W)
append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WNO_UNUSED_PARAMETER_FLAG -Wno-unused-parameter)
append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WWRITE_STRINGS_FLAG -Wwrite-strings)
append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WNO_LONG_LONG_FLAG -Wno-long-long)
if (LIBCXX_ENABLE_WERROR)
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WERROR_FLAG -Werror)
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WX_FLAG -WX)
else()
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_WNO_ERROR_FLAG -Wno-error)
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_NO_WX_FLAG -WX-)
endif()
if (LIBCXX_ENABLE_PEDANTIC)
  append_if(LIBCXX_CXX_WARNING_FLAGS LIBCXX_HAS_PEDANTIC_FLAG -pedantic)
endif()

# Get feature flags.
# Exceptions
if (LIBCXX_ENABLE_EXCEPTIONS)
  # Catches C++ exceptions only and tells the compiler to assume that extern C
  # functions never throw a C++ exception.
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_EHSC_FLAG -EHsc)
else()
  list(APPEND LIBCXX_CXX_FEATURE_FLAGS -D_LIBCPP_NO_EXCEPTIONS)
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_NO_EHS_FLAG -EHs-)
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_NO_EHA_FLAG -EHa-)
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_FNO_EXCEPTIONS_FLAG -fno-exceptions)
endif()
# RTTI
if (NOT LIBCXX_ENABLE_RTTI)
  list(APPEND LIBCXX_CXX_FEATURE_FLAGS -D_LIBCPP_NO_RTTI)
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_NO_GR_FLAG -GR-)
  append_if(LIBCXX_CXX_FEATURE_FLAGS LIBCXX_HAS_FNO_RTTI_FLAG -fno-rtti)
endif()
# Assert
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (LIBCXX_ENABLE_ASSERTIONS)
  # MSVC doesn't like _DEBUG on release builds. See PR 4379.
  if (NOT MSVC)
    list(APPEND LIBCXX_CXX_FEATURE_FLAGS -D_DEBUG)
  endif()
  # On Release builds cmake automatically defines NDEBUG, so we
  # explicitly undefine it:
  if (uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBCXX_CXX_FEATURE_FLAGS -UNDEBUG)
  endif()
else()
  if (NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBCXX_CXX_FEATURE_FLAGS -DNDEBUG)
  endif()
endif()
# Static library
if (NOT LIBCXX_ENABLE_SHARED)
  list(APPEND LIBCXX_CXX_FEATURE_FLAGS -D_LIBCPP_BUILD_STATIC)
endif()

# This is the _ONLY_ place where add_definitions is called.
if (MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

add_definitions(
 ${LIBCXX_CXX_REQUIRED_FLAGS}
 ${LIBCXX_CXX_WARNING_FLAGS}
 ${LIBCXX_CXX_FEATURE_FLAGS}
 )

#===============================================================================
# Setup Source Code
#===============================================================================

include_directories(include)
add_subdirectory(include)

# Add source code. This also contains all of the logic for deciding linker flags
# soname, etc...
add_subdirectory(lib)

#===============================================================================
# Setup Tests
#===============================================================================

add_subdirectory(test)

=== Makefile ===
##
# libc++ Makefile
##

SRCDIRS = .
DESTDIR = $(DSTROOT)

OBJROOT=.
SYMROOT=.
export TRIPLE=-apple-

ifeq (,$(RC_INDIGO))
	INSTALL_PREFIX=""
else
	INSTALL_PREFIX="$(SDKROOT)"
endif
INSTALL_DIR=$(DSTROOT)/$(INSTALL_PREFIX)

.PHONY: help installsrc clean installheaders install

help::
	@echo "Use make install DSTROOT=<destination>"

installsrc:: $(SRCROOT)

	ditto $(SRCDIRS)/include $(SRCROOT)/include
	ditto $(SRCDIRS)/lib $(SRCROOT)/lib
	ditto $(SRCDIRS)/src $(SRCROOT)/src
	ditto $(SRCDIRS)/Makefile $(SRCROOT)/Makefile

clean::

# The installheaders target is used by clang's runtime/libcxx makefile.
installheaders::
	mkdir -p $(HEADER_DIR)/c++/v1/ext
	(cd $(SRCDIRS)/include && tar cf - --exclude=support .) | \
	  (cd $(HEADER_DIR)/c++/v1 && tar xf -)
	chmod 755 $(HEADER_DIR)/c++/v1
	chmod 644 $(HEADER_DIR)/c++/v1/*
	chmod 755 $(HEADER_DIR)/c++/v1/ext
	chmod 644 $(HEADER_DIR)/c++/v1/ext/*
	chmod 755 $(HEADER_DIR)/c++/v1/experimental
	chmod 644 $(HEADER_DIR)/c++/v1/experimental/*

install::

	cd lib && ./buildit
	ditto lib/libc++.1.dylib $(SYMROOT)/usr/lib/libc++.1.dylib
	cd lib && dsymutil -o $(SYMROOT)/libc++.1.dylib.dSYM \
	  $(SYMROOT)/usr/lib/libc++.1.dylib
	mkdir -p $(INSTALL_DIR)/usr/lib
	strip -S -o $(INSTALL_DIR)/usr/lib/libc++.1.dylib \
	  $(SYMROOT)/usr/lib/libc++.1.dylib
	cd $(INSTALL_DIR)/usr/lib && ln -s libc++.1.dylib libc++.dylib

=== lib/CMakeLists.txt ===
# Get sources
file(GLOB LIBCXX_SOURCES ../src/*.cpp)
if(WIN32)
  file(GLOB LIBCXX_WIN32_SOURCES ../src/support/win32/*.cpp)
  list(APPEND LIBCXX_SOURCES ${LIBCXX_WIN32_SOURCES})
endif()

# Add all the headers to the project for IDEs.
if (MSVC_IDE OR XCODE)
  file(GLOB_RECURSE LIBCXX_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../include/*)
  if(WIN32)
    file( GLOB LIBCXX_WIN32_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../include/support/win32/*.h)
    list(APPEND LIBCXX_HEADERS ${LIBCXX_WIN32_HEADERS})
  endif()
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  if (MSVC_IDE)
    source_group("Header Files" FILES ${LIBCXX_HEADERS})
  endif()
endif()

if (LIBCXX_ENABLE_SHARED)
  add_library(cxx SHARED
    ${LIBCXX_SOURCES}
    ${LIBCXX_HEADERS}
    )
else()
  add_library(cxx STATIC
    ${LIBCXX_SOURCES}
    ${LIBCXX_HEADERS}
    )
endif()

if (DEFINED LIBCXX_CXX_ABI_DEPS)
  add_dependencies(cxx ${LIBCXX_CXX_ABI_DEPS})
endif()

# Generate library list.
set(libraries ${LIBCXX_CXX_ABI_LIBRARIES})
append_if(libraries LIBCXX_HAS_PTHREAD_LIB pthread)
append_if(libraries LIBCXX_HAS_C_LIB c)
append_if(libraries LIBCXX_HAS_M_LIB m)
append_if(libraries LIBCXX_HAS_RT_LIB rt)
append_if(libraries LIBCXX_HAS_GCC_S_LIB gcc_s)

target_link_libraries(cxx ${libraries})

# Setup flags.
append_if(compile_flags LIBCXX_HAS_FPIC_FLAG -fPIC)
append_if(link_flags LIBCXX_HAS_NODEFAULTLIBS_FLAG -nodefaultlibs)

if ( APPLE )
  if ( CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6" )
    list(APPEND compile_flags "-U__STRICT_ANSI__")
    list(APPEND link_flags
      "-compatibility_version 1"
      "-current_version ${LIBCXX_VERSION}"
      "-install_name /usr/lib/libc++.1.dylib"
      "-Wl,-reexport_library,/usr/lib/libc++abi.dylib"
      "-Wl,-unexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++unexp.exp"
      "/usr/lib/libSystem.B.dylib")
  else()
    if ( ${CMAKE_OSX_SYSROOT} )
      list(FIND ${CMAKE_OSX_ARCHITECTURES} "armv7" OSX_HAS_ARMV7)
      if (OSX_HAS_ARMV7)
        set(OSX_RE_EXPORT_LINE
          "${CMAKE_OSX_SYSROOT}/usr/lib/libc++abi.dylib"
          "-Wl,-reexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++sjlj-abi.exp")
      else()
        set(OSX_RE_EXPORT_LINE
          "-Wl,-reexport_library,${CMAKE_OSX_SYSROOT}/usr/lib/libc++abi.dylib")
      endif()
    else()
      set (OSX_RE_EXPORT_LINE "/usr/lib/libc++abi.dylib -Wl,-reexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++abi${LIBCXX_LIBCPPABI_VERSION}.exp")
    endif()

    list(APPEND link_flags
      "-compatibility_version 1"
      "-install_name /usr/lib/libc++.1.dylib"
      "-Wl,-unexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++unexp.exp"
      "${OSX_RE_EXPORT_LINE}"
      "-Wl,-force_symbols_not_weak_list,${CMAKE_CURRENT_SOURCE_DIR}/notweak.exp"
      "-Wl,-force_symbols_weak_list,${CMAKE_CURRENT_SOURCE_DIR}/weak.exp")
  endif()
endif()

string(REPLACE ";" " " link_flags "${link_flags}")

set_target_properties(cxx
  PROPERTIES
    COMPILE_FLAGS "${compile_flags}"
    LINK_FLAGS    "${link_flags}"
    OUTPUT_NAME   "c++"
    VERSION       "1.0"
    SOVERSION     "1"
  )

install(TARGETS cxx
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  )

=== test/CMakeLists.txt ===
macro(pythonize_bool var)
  if (${var})
    set(${var} True)
  else()
    set(${var} False)
  endif()
endmacro()

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
  if(LIBCXX_BUILT_STANDALONE)
    set(LIT_EXECUTABLE "" CACHE FILEPATH "Path to LLVM's lit.py.")
  else()
    set(LIT_EXECUTABLE "${CMAKE_SOURCE_DIR}/utils/lit/lit.py")
  endif()

  set(LIT_ARGS_DEFAULT "-sv")
  if (MSVC OR XCODE)
    set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
  endif()
  set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}"
      CACHE STRING "Default options for lit")
  set(LIT_ARGS "${LLVM_LIT_ARGS}")
  separate_arguments(LIT_ARGS)

  set(LIBCXX_COMPILER ${CMAKE_CXX_COMPILER})
  set(LIBCXX_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/..)
  set(LIBCXX_BINARY_DIR ${CMAKE_BINARY_DIR})
  set(PYTHON_EXECUTABLE ${PYTHON_EXECUTABLE})
  pythonize_bool(LIBCXX_ENABLE_SHARED)
  pythonize_bool(LIBCXX_HAS_STDCXX0X_FLAG)

  set(AUTO_GEN_COMMENT "## Autogenerated by libcxx configuration.\n# Do not edit!")

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg
    @ONLY)

  add_custom_target(check-libcxx
    COMMAND ${PYTHON_EXECUTABLE}
            ${LIT_EXECUTABLE}
            ${LIT_ARGS}
            ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS cxx
    COMMENT "Running libcxx tests")
else()
  message(WARNING "Could not find Python, no check target will be available!")
endif()

## libc++ 1.0~svn181765

=== debian/changelog ===
libc++ (1.0~svn181765-1) unstable; urgency=low

  * New snapshot release
  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 14 May 2013 10:41:44 +0200

libc++ (1.0~svn180177-1~exp1) experimental; urgency=low

  * New upstream release
  * Minimal clang version (>= 3.2)
  * Standards-Version updated to version 3.9.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 24 Apr 2013 09:32:41 +0200

libc++ (1.0~svn170866-1~exp1) experimental; urgency=low

  * New snapshot release
  * libc++-dev now provides libstdc++-dev
  * Update of the homepage
  * Update the minimal version of debhelper (9)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Dec 2012 09:45:40 +0100

libc++ (1.0~svn161106-1~exp1) experimental; urgency=low

  * New snapshot release

  [ Andrej Belym ]
  * Multiarch support.

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 01 Aug 2012 10:38:08 +0200

libc++ (1.0~svn160132-1~exp1) experimental; urgency=low

  * Initial release (Closes: #682245)

 -- Andrej Belym <white.wolf.2105@gmail.com>  Sat, 02 Jun 2012 19:25:47 +0400

=== debian/control ===
Source: libc++
Priority: extra
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
Standards-Version: 3.9.4
Section: libs
Homepage: http://libcxx.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/libcxx/trunk/

Package: libc++1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: clang
Description: LLVM C++ Standard library
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Provides: libstdc++-dev
Description: LLVM C++ Standard library (development files)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-src
Section: libs
Architecture: any
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM C++ Standard library (source and test cases)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the sources and test cases of libc++ library.

Package: libc++abi1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LLVM low level support for a standard C++ library
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM low level support for a standard C++ library (development files)
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-src
Section: libs
Architecture: any
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: libc++abi source and test cases
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .
 Sources and test cases of libc++abi library.

## libc++ 1.0~svn199600

=== debian/changelog ===
libc++ (1.0~svn199600-1) unstable; urgency=low

  * New snapshot release
  * Standards-Version updated to 3.9.5
  * Introduce package libc++-helpers (Closes: #718637)
  * Rename libc++-src => libc++-test
  * Rename libc++abi-src => libc++abi-test
  * For both, remove the sources from the packages (apt-get source libc++)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 19 Jan 2014 15:25:24 +0100

libc++ (1.0~svn196040-1) unstable; urgency=low

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 01 Dec 2013 11:00:53 +0100

libc++ (1.0~svn189766-1) unstable; urgency=low

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 02 Sep 2013 19:43:49 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
 Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: libs
 Homepage: http://libcxx.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
@@ -34,7 +34,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
+Depends: libc++1 (= ${binary:Version}), ${misc:Depends}, libc++-helpers
 Provides: libstdc++-dev
 Description: LLVM C++ Standard library (development files)
  libc++ is a new implementation of the C++ standard library, targeting C++11.
@@ -49,11 +49,13 @@
      as exception objects, rtti and memory allocation.
    * Extensive unit tests.
 
-Package: libc++-src
+Package: libc++-test
 Section: libs
 Architecture: any
 Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
-Description: LLVM C++ Standard library (source and test cases)
+Replaces: libc++-src (<< 1.0~svn199600-1)
+Breaks: libc++-src (<< 1.0~svn199600-1)
+Description: LLVM C++ Standard library (test cases)
  libc++ is a new implementation of the C++ standard library, targeting C++11.
  .
  Features and Goals
@@ -66,7 +68,7 @@
      as exception objects, rtti and memory allocation.
    * Extensive unit tests.
  .
- This package contains the sources and test cases of libc++ library.
+ This package contains the test cases of libc++ library.
 
 Package: libc++abi1
 Section: libs
@@ -99,11 +101,13 @@
    * Provide a portable sublayer to ease the porting of libc++
  .
 
-Package: libc++abi-src
+Package: libc++abi-test
 Section: libs
 Architecture: any
 Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
-Description: libc++abi source and test cases
+Replaces: libc++abi-src (<< 1.0~svn199600-1)
+Breaks: libc++abi-src (<< 1.0~svn199600-1)
+Description: libc++abi test cases
  libc++abi is a new implementation of low level support for a standard C++
  library.
  .
@@ -112,4 +116,26 @@
    * Correctness as defined by the C++11 standard.
    * Provide a portable sublayer to ease the porting of libc++
  .
- Sources and test cases of libc++abi library.
+ Test cases of libc++abi library.
+
+
+Package: libc++-helpers
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Replaces: libc++-dev (<< 1.0~svn199600-1)
+Breaks: libc++-dev (<< 1.0~svn199600-1)
+Description: LLVM C++ Standard library - build helpers
+ libc++ is a new implementation of the C++ standard library, targeting C++11.
+ .
+ Features and Goals
+ .
+   * Correctness as defined by the C++11 standard.
+   * Fast execution.
+   * Minimal memory use.
+   * Fast compile times.
+   * ABI compatibility with gcc's libstdc++ for some low-level features such
+     as exception objects, rtti and memory allocation.
+   * Extensive unit tests.
+ .
+ This package contains the build helpers (clang++-libc++, etc)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

%:
	dh $@

override_dh_auto_clean:
	cd libcxxabi/test;rm -f a.out;
	cd libcxxabi/lib; rm -f libc++abi.a libc++abi.so.1.0 libc++abi.so libc++abi.so.1 *.o;
	cd libcxx/lib; rm -f libc++.a libc++.so.1.0 libc++.so libc++.so.1.0 libc++.so.1 *.o;

override_dh_auto_build:
	cd libcxxabi/lib; ./buildit; ln -s libc++abi.so.1.0 libc++abi.so;\
	ln -s libc++abi.so.1.0 libc++abi.so.1;
	cd libcxx/lib; ./buildit; ln -s libc++.so.1.0 libc++.so;\
	ln -s libc++.so.1.0 libc++.so.1;

.PHONY: get-orig-source
get-orig-source:
	sh debian/libc++-get-orig-source.sh $(SRC_VERSION)

## libc++ 3.5

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 endif()
 
 if (DEFINED LIBCXX_CXX_ABI_DEPS)
-  add_dependencies(cxx ${LIBCXX_CXX_ABI_DEPS})
+  add_dependencies(cxx LIBCXX_CXX_ABI_DEPS)
 endif()
 
 # Generate library list.

=== debian/changelog ===
libc++ (3.5-2) unstable; urgency=medium

  * Remove a useless patch libcxx-use_libcxxabi.patch (Closes: #762354)
  * g++-libc++ helper now manages option -pthread (Closes: #760542)
    Thanks to Miles Bader for the patch
  * Fix the FTBFS under ARM/ARMHF by disabling the ARM EHABI exception handling
    (Closes: #761193)
  * Fails the build in case of error
  * Fix some files layout issues

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 28 Sep 2014 23:01:19 +0200

libc++ (3.5-1) unstable; urgency=medium

  * New upstream release
  * Now that libcxxabi is also official released, use stable releases
  * Update of the repack script
  * syntax-error-in-dep5-copyright fixed
  * Depends on clang instead of clang-X.Y

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Sep 2014 16:32:53 +0200

libc++ (1.0~svn216840-1) unstable; urgency=medium

  * New snapshot release
  * Update the dependency from clang-3.4 to clang (co install)
    (Closes: #759938)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 31 Aug 2014 11:32:59 +0200

libc++ (1.0~svn205159-1) unstable; urgency=medium

  * New snapshot release
  * Force the usage of clang 3.4 (Closes: #736991)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 30 Mar 2014 21:26:14 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
+Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
 Standards-Version: 3.9.5
 Section: libs
 Homepage: http://libcxx.llvm.org/
